﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.ObjectModel;
using Caliburn.Micro;
using System.ComponentModel.Composition;
using DockingAdapterMVVM;
using System.Windows.Controls;

namespace DockingManagerMVVMCaliburnMicro
{
    [Export(typeof(DockingAdapterViewModel))]
    public class DockingAdapterViewModel : PropertyChangedBase
    {
        private ObservableCollection<Workspace> dockingadapter;

        public ObservableCollection<Workspace> DockingAdapter
        {
            get { return dockingadapter; }
            set { dockingadapter = value; }
        }

        public DockingAdapterViewModel()
        {
            DockingAdapter = new ObservableCollection<Workspace>();

            ToolboxViewModel toolbox = new ToolboxViewModel() { Name = "ToolboxWindow", Header = "Toolbox", State = DockState.AutoHidden, CanClose = false, SideInDockMode = DockSide.Left, DesiredWidthInDockedMode = 250 };
            
            ErrorListViewModel errorlist = new ErrorListViewModel() { Name = "ErrorListWindow", Header = "Error List", State = DockState.Dock, SideInDockMode = DockSide.Bottom, CanClose = false, DesiredHeightInDockedMode = 200 };
            FindSymbolResultsViewModel findsymbolresults = new FindSymbolResultsViewModel() { Name = "FindSymbolResultsWindow", Header = "Find Symbol Results", State = DockState.Dock, CanClose = false, TargetNameInDockedMode = "ErrorListWindow", SideInDockMode = DockSide.Tabbed };
            OutputViewModel output = new OutputViewModel() { Name = "OutputWindow", Header = "Output", State = DockState.Dock, TargetNameInDockedMode = "ErrorListWindow", CanClose = false, SideInDockMode = DockSide.Tabbed };
            FindResultsViewModel findresults = new FindResultsViewModel() { Name = "FindResults1Window", Header = "Find Results 1", State = DockState.Dock, TargetNameInDockedMode = "ErrorListWindow", CanClose = false, SideInDockMode = DockSide.Tabbed };

            MainWindowXAMLViewModel mainwindowxaml = new MainWindowXAMLViewModel() { Header = "MainWindow.xaml", State = DockState.Document };
            MainWindowCSViewModel mainwindowcs = new MainWindowCSViewModel() { Header = "MainWindow.xaml.cs", State = DockState.Document };

            SolutionExplorerViewModel solutionexplorer = new SolutionExplorerViewModel() { Name = "SolutionExplorerWindow", Header = "Solution Explorer", State = DockState.Dock, CanResizeInDockedState = false, CanClose = false, SideInDockMode = DockSide.Right};
            //ClassViewModel classview = new ClassViewModel() { Name = "ClassViewWindow", Header = "Class View", State = DockState.Dock, TargetNameInDockedMode = "SolutionExplorerWindow", CanClose = false, SideInDockMode = DockSide.Tabbed };
            //PropertiesViewModel properties = new PropertiesViewModel() { Name = "PropertiesWindow", Header = "Properties", State = DockState.Dock, TargetNameInDockedMode = "SolutionExplorerWindow", CanClose = false, SideInDockMode = DockSide.Tabbed };

            DockingAdapter.Add(toolbox);
            DockingAdapter.Add(solutionexplorer);
            //DockingAdapter.Add(classview);
            //DockingAdapter.Add(properties);
            DockingAdapter.Add(errorlist);
            DockingAdapter.Add(findsymbolresults);
            DockingAdapter.Add(output);
            DockingAdapter.Add(findresults);
            DockingAdapter.Add(mainwindowxaml);
            DockingAdapter.Add(mainwindowcs);
        }

        public Syncfusion.Windows.Tools.Controls.DockingManager AdapterDockingManager { get; set; }

        public void DockingManagerLoaded(DockingAdapterViewModel model)
        {
            AdapterDockingManager = (((App.Current.MainWindow as ShellView).Docking.Content as DockingAdapterView).DockingAdapter.Content as Grid).Children[0] as Syncfusion.Windows.Tools.Controls.DockingManager;
        }
    }
}
